<?php
/**
 * @package n3tComingSoon
 * @author Pavel Poles - n3t.cz
 * @copyright (C) 2010 - 2011 - Pavel Poles - n3t.cz
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );
jimport( 'joomla.filesystem.file' );
jimport('joomla.version');

class plgSystemN3tComingSoon extends JPlugin
{
  private $redirect = false;

	function plgSystemN3tComingSoon(& $subject, $config)
	{
		parent::__construct($subject, $config);
    $this->redirect = false;
	}
  
  private function extensionInstalled($name)
  {
    switch($name) {
      case 'com_acymailing':
        return include_once(rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_acymailing'.DS.'helpers'.DS.'helper.php');
        break;
    }
    return false;
  }

  private function getAcyMailingLists() {
    $acymailing_lists = $this->params->def('acymailing_lists', '');
    $listsClass = acymailing_get('class.list');
    $allLists = $listsClass->getLists('listid');
    $acyListsArray = array();
    if(acymailing_level(1)) {
      $allLists = $listsClass->onlyCurrentLanguage($allLists);
    }
    if(acymailing_level(3)){
    	$my = JFactory::getUser();
    	foreach($allLists as $listid => $oneList){
    		if(!$allLists[$listid]->published) continue;
    		if(!acymailing_isAllowed($oneList->access_sub)){
    			$allLists[$listid]->published = false;
    		}
    	}
    }
    if(strpos($acymailing_lists,',') OR is_numeric($acymailing_lists)){
    	$acymailing_lists = explode(',',$acymailing_lists);
    	foreach($allLists as $oneList){
    		if($oneList->published AND in_array($oneList->listid,$acymailing_lists)) $acyListsArray[] = $oneList->listid;
    	}
    }elseif($acymailing_lists == ''){
    	foreach($allLists as $oneList){
    		if(!empty($oneList->published)){$acyListsArray[] = $oneList->listid;}
    	}
    }
    return implode(',',$acyListsArray);
  }

  private function getMessages() {
		$buffer = '';
		$lists = null;
		$messages = JFactory::getApplication()->getMessageQueue();
		if (is_array($messages) && !empty($messages)) {
			foreach ($messages as $msg) {
				if (isset($msg['type']) && isset($msg['message']))
					$lists[$msg['type']][] = $msg['message'];
			}
		}

		if (is_array($lists)) {
			$buffer .= "\n<dl id=\"system-message\">";
			foreach ($lists as $type => $msgs)
			{
				if (count($msgs))
				{
					$buffer .= "\n<dt class=\"" . strtolower($type) . "\">" . JText::_($type) . "</dt>";
					$buffer .= "\n<dd class=\"" . strtolower($type) . " message\">";
					$buffer .= "\n\t<ul>";
					foreach ($msgs as $msg)
					{
						$buffer .= "\n\t\t<li>" . $msg . "</li>";
					}
					$buffer .= "\n\t</ul>";
					$buffer .= "\n</dd>";
				}
			}
			$buffer .= "\n</dl>";
		}
		return $buffer;
  }

  public function onAfterInitialise()   
  {
    $app =& JFactory::getApplication(); 
    if ($app->isSite()) {
      $can_display = false;
      
      $online = $this->params->def('online', '');
      $get_filter = trim($this->params->def('get_filter', ''));
      $ip_filter = trim($this->params->def('ip_filter', ''));
      $acymailing_enabled = $this->params->def('maillist', 'none') == 'acymailing' && $this->extensionInstalled('com_acymailing');
      if ($acymailing_enabled) {
        $acymailing_lists = $this->getAcyMailingLists();
      }

      if ($online) {        
        $date_online =& JFactory::getDate($online);
        $date_now =& JFactory::getDate('now');
        if (JVersion::isCompatible('1.6.0')) {  
          $date_now->setTimeZone(new DateTimeZone($app->getCfg('offset')));
          $unix_now = $date_now->toUnix();
          $unix_now += $date_now->getOffsetFromGMT();            
        } else {
          $date_now->setOffset($app->getCfg('offset'));
          $unix_now = $date_now->toUnix(true);
        }          
        if ($date_online->toUnix() <= $unix_now) 
        { 
      	  $db =& JFactory::getDBO();  	  
          if (JVersion::isCompatible('1.6.0')) {
            $db->setQuery('UPDATE #__extensions SET enabled=0 WHERE type="plugin" AND element="n3tcomingsoon" AND folder="system"');
          } else {
            $db->setQuery('UPDATE #__plugins SET published=0 WHERE element="n3tcomingsoon" AND folder="system"');
          }	 
          $db->query();     
          $can_display = true;
        } else {
          $seconds_online = $date_online->toUnix() - $unix_now;          
          $date_online = $date_online->toFormat($this->params->def('date_format', '%Y-%m-%d %H:%M'));
        }
      } else {
        $seconds_online = 0;
        $date_online = false;
      }      
      if (!$can_display && $get_filter) {
        $can_display = $app->getUserStateFromRequest( $this->_name.".get_filter", $get_filter, '' );
      }
      if (!$can_display && $ip_filter) {
        $ip_filter = preg_split('/\s*\n\s*/', $ip_filter);
        $can_display = array_search($_SERVER['REMOTE_ADDR'], $ip_filter) !== false;
      }
      if (!$can_display && $acymailing_enabled) {
        $can_display = JRequest::getCmd('option') == 'com_acymailing'
          && JRequest::getCmd('task') == 'optin'
          && JRequest::getInt('ajax') == 1
          && JRequest::getCmd('ctrl') == 'sub'
          && JRequest::getString('hiddenlists') == $acymailing_lists;
      }
      if (!$can_display && $acymailing_enabled) {
        $can_display = JRequest::getCmd('option') == 'com_acymailing'
          && JRequest::getCmd('task') == 'confirm'
          && JRequest::getCmd('ctrl') == 'user';
        if ($can_display) $this->redirect = true;
      }
      if (!$can_display) {
        $custom_file = $this->params->def('custom_file', '');
                
  	    JResponse::setHeader('Content-Type', 'text/html; charset=utf-8');
        JResponse::sendHeaders();        

        $this->loadLanguage('', JPATH_ADMINISTRATOR);
   
        $theme = $this->params->def('theme', 'light');
        $logo = $this->params->def('logo', '');
        $background_image = $this->params->def('background_image', '');
        $favicon = $this->params->def('favicon', '');
        $title = $this->params->def('title', $app->getCfg('sitename'));
        $text = $this->params->def('text', JText::_('PLG_SYSTEM_N3TCOMINGSOON_COMING_SOON'));          
        $meta_title = $this->params->def('meta_title', $title);
        $meta_desc = $this->params->def('meta_desc', $app->getCfg('MetaDesc'));
        $meta_keys = $this->params->def('meta_keys', $app->getCfg('MetaKeys'));
        $custom_css = $this->params->def('custom_css', '');
        $maillist_text = $this->params->def('maillist_text', '');
        $messages = $this->getMessages();
        
        if ($this->params->def('prepare_content', 0)) {
          $title = JHtml::_('content.prepare', $title);
          $text = JHtml::_('content.prepare', $text); 
          $maillist_text = JHtml::_('content.prepare', $maillist_text);
        }
        
        if ($custom_file && JFile::exists(JPATH_BASE.DS.$custom_file)) {
          require(JPATH_BASE.DS.$custom_file);
        } else {                  
          require(JPATH_BASE.DS.'media'.DS.'plg_n3tcomingsoon'.DS.'soon.php');
        }
        $app->close();
      }
    }
  }	

  public function onAfterDispatch()
  {
    if ($this->redirect) {
      $app =& JFactory::getApplication();
      $app->redirect('/');
    }
  }
}